<?php
// $Id: uc_cashnet.pages.inc,v 1.1.2.5 2010/08/11 17:52:20 islandusurper Exp $

/**
 * @file
 * cashnet menu items.
 *
 */

function uc_cashnet_complete($cart_id = 0) {
  watchdog('uc_cashnet', 'Receiving new order notification for order !order_id.', array('!order_id' => check_plain($_POST['ref1val1'])));

  $order = uc_order_load($_POST['ref1val1']);

  if ($order === FALSE || uc_order_status_data($order->order_status, 'state') != 'in_checkout') {
    return t('An error has occurred during payment.  Please contact us to ensure your order has submitted.');
  }
  
  $total = 0;
  for ($x = 1; $x <= $_POST['itemcnt']; $x++) {
    $total += $_POST['amount'.$x];
  }
  
  // check order total against total incoming
  if ($total !== uc_order_get_total($order)) {
    watchdog('uc_cashnet', 'Incoming total for order %d did not match our internal total of %d', array($order->order_id, $total), WATCHDOG_ERROR);
    return t('An error has occurred during payment.  Please contact us to ensure your order has submitted.');
  }
  
  if ($_POST['respmessage'] == 'SUCCESS') {
    $comment = t('Paid by !type, cashnet.com order #!order.', array('!type' => $_POST['pmttype'], '!order' => check_plain($_POST['ref1val1'])));
    uc_payment_enter($order->order_id, 'cashnet', $total, 0, NULL, $comment);
  }
  else {
    drupal_set_message(t('Your order will be processed as soon as your payment clears at cashnet.com.'));
    uc_order_comment_save($order->order_id, 0, t('!type payment is pending approval at cashnet.com.', array('!type' => $_POST['pmttype'])), 'admin');
  }

  // Empty that cart...
  uc_cart_empty($cart_id);

  // Save changes to order without it's completion.
  uc_order_save($order);

  // Add a comment to let sales team know this came in through the site.
  uc_order_comment_save($order->order_id, 0, t('Order created through website.'), 'admin');

  $output = uc_cart_complete_sale($order, variable_get('uc_new_customer_login', FALSE));

  $page = variable_get('uc_cart_checkout_complete_page', '');

  if (!empty($page)) {
    drupal_goto($page);
  }

  return $output;
}
